org 100h
bits 16

%xdefine _x86_Portable__PLATFORMBITS_ 1632
%include "x86p.asm"



;                mov     ax,13h                  ; init vga
;                int     10h

;Inputs:
;---------------
;BX: Value bits to select mono or color port:
;                   --
;          0000000001000000b -- color (produce 0x3DA)
;          0000000000100000b -- mono  (produce 0x3BA)
 ;                   --
;
;ESI == Base address of the register set
;;
 mov ax,13h
 int 10h
 mov bx,0000000001000000b
 mov esi,CGA_320x240x256_ModeX_Gen__Regs
 mov esi,VGA_640x480x16Gen__Regs
 mov esi,CGA_320x200x4Gen__MiscOutputReg
 mov esi,MCGA_320x200x256Gen__Regs
 call VGA_Config_All_Regs



               ;push    0000h
                push    0xA000
                pop     es




call _3drot




               ;Return to text mode:
               ;;
                mov     ax,3
                int     10h

                mov     wideax,4c00h
                int     21h








_3drot:
 pushfwide
 pusha

start:

._3drot_mainloop:
hlt
                add     wideword[_3drot_xangle],1              ; increase x,y,z-angles
hlt
                and     wideword[_3drot_xangle],255
hlt
                add     wideword[_3drot_yangle],1
hlt
                and     wideword[_3drot_yangle],255
hlt
                add     wideword[_3drot_zangle],1
hlt
                and     wideword[_3drot_zangle],255
hlt

                mov     widebx,wideword[_3drot_xangle]             ; get x,y,z,-sin/cos value
hlt
                movsx   bp,[_3drot_sincos+widebx]
hlt
                mov     wideword[_3drot_xsin],widebp
hlt
                add     widebx,64
hlt
                and     widebx,255
hlt
                movsx   bp,[_3drot_sincos+widebx]
hlt
                mov     wideword[_3drot_xcos],widebp
hlt
                mov     widebx,wideword[_3drot_yangle]
hlt
                movsx   bp,[_3drot_sincos+bx]
hlt
                mov     wideword[_3drot_ysin],widebp
hlt
                add     widebx,64
hlt
                and     widebx,255
hlt
                movsx   bp,[_3drot_sincos+bx]
hlt
                mov     wideword[_3drot_ycos],widebp
hlt
                mov     widebx,wideword[_3drot_zangle]
hlt
                movsx   bp,[_3drot_sincos+widebx]
hlt
                mov     wideword[_3drot_zsin],widebp
hlt
                add     widebx,64
hlt
                and     widebx,255
hlt
                movsx   bp,[_3drot_sincos+bx]
hlt
                mov     wideword[_3drot_zcos],widebp
hlt

                xor     widesi,widesi
hlt
._3drot_morepoints:
                mov     wideax,wideword[_3drot_coords+widesi+2]        ; do calculations
hlt
                imul    word[_3drot_xcos]
hlt
                mov     widebp,wideax
hlt
                mov     wideax,wideword[_3drot_coords+widesi+4]
hlt
                imul    word[_3drot_xsin]
hlt
                sub     widebp,wideax
hlt
                mov     wideword[_3drot_yt],widebp
hlt
                mov     wideax,wideword[_3drot_coords+widesi+2]
hlt
                imul    word[_3drot_xsin]
hlt
                mov     widebp,wideax
hlt
                mov     wideax,wideword[_3drot_coords+widesi+4]
hlt
                imul    word[_3drot_xcos]
hlt
                add     widebp,wideax
hlt
                mov     wideword[_3drot_zt],widebp
hlt
                mov     wideax,wideword[_3drot_yt]
hlt
                sar     ax,7
hlt
                mov     wideword[_3drot_y],wideax
hlt
                mov     wideax,wideword[_3drot_zt]
hlt
                sar     ax,7
hlt
                mov     wideword[_3drot_z],wideax
hlt

                mov     wideax,wideword[_3drot_coords+widesi]
hlt
                imul    wideword[_3drot_ycos]
hlt
                mov     widebp,wideax
hlt
                mov     wideax,wideword[_3drot_z]
hlt
                imul    wideword[_3drot_ysin]
hlt
                sub     widebp,wideax
hlt
                mov     wideword[_3drot_xt],widebp
hlt
                mov     wideax,wideword[_3drot_coords+widesi]
hlt
                imul    wideword[_3drot_ysin]
hlt
                mov     widebp,wideax
hlt
                mov     wideax,wideword[_3drot_z]
hlt
                imul    wideword[_3drot_ycos]
hlt
                add     widebp,wideax
hlt
                mov     wideword[_3drot_zt],widebp
hlt
                mov     wideax,wideword[_3drot_xt]
hlt
                sar     ax,7
hlt
                mov     wideword[_3drot_x],wideax
hlt
                mov     wideax,wideword[_3drot_zt]
hlt
                sar     ax,7
hlt
                mov     wideword[_3drot_z],wideax
hlt

                mov     wideax,wideword[_3drot_x]
hlt
                imul    wideword[_3drot_zcos]
hlt
                mov     widebp,wideax
hlt
                mov     wideax,wideword[_3drot_y]
hlt
                imul    word[_3drot_zsin]
hlt
                sub     widebp,wideax
hlt
                mov     wideword[_3drot_xt],widebp
hlt
                mov     wideax,wideword[_3drot_x]
hlt
                imul    word[_3drot_zsin]
hlt
                mov     widebp,wideax
hlt
                mov     wideax,wideword[_3drot_y]
hlt
                imul    word[_3drot_zcos]
hlt
                add     widebp,wideax
hlt
                mov     wideword[_3drot_yt],widebp;nomodify
hlt
                mov     wideax,wideword[_3drot_xt]
hlt
                sar     ax,7
hlt
                mov     wideword[_3drot_x],wideax
hlt
                mov     wideax,wideword[_3drot_yt]
hlt
                sar     ax,7
hlt
                mov     wideword[_3drot_y],wideax
hlt

                mov     wideax,200
hlt
                imul    word[_3drot_x];nomodify
hlt
                mov     widebp,wideword[_3drot_z]
hlt
                add     widebp,200
hlt
                idiv    bp;nomodify (blocked and nothing on screen)
hlt
                add     ax,160;nomodify (half right globe)
hlt
                mov     widecx,wideax
hlt

                mov     wideax,200
hlt
                imul    word[_3drot_y]
hlt
                mov     widebp,wideword[_3drot_z]
hlt
                add     widebp,200
hlt
                idiv    bp;nomodify
hlt
                add     ax,100;nomodify (only lower half of animation)
hlt

		mov	widedi,wideax
hlt
		shl	widedi,8
hlt
		shl	wideax,6
hlt
		add	widedi,wideax
hlt
		add	widedi,widecx
hlt

                mov     [_3drot_erase+widesi],di
hlt
                ;add widedi,0A0000h
                ;mov     byte[es:widedi],15
                push wideax
hlt
                mov al,15
hlt
                ;awide stosb
                stosb
hlt
                pop wideax
hlt
                ;sub widedi,0A0001h

                add     widesi,6
hlt
                cmp     widesi,_3drot_points
hlt
                jne     ._3drot_morepoints
hlt

                mov     dx,3dah
hlt
                .l1:
                in      al,dx
hlt
                test    al,8
hlt
                jne     .l1;$-3
hlt
                .l2:
                in      al,dx
hlt
                test    al,8
hlt
                je      .l2;$-3
hlt

                xor     widesi,widesi                   ; erase the points again
hlt
._3drot_killem: mov     di,[_3drot_erase+widesi]
hlt
                ;add widedi,0A0000h
                 ;mov     byte[es:widedi],0
                push wideax
hlt
                mov al,0
hlt
                ;awide stosb
                stosb
hlt
                pop wideax
hlt
                ;sub widedi,0A0001h
                add     widesi,6
hlt
                cmp     widesi,_3drot_points
hlt
                jne     ._3drot_killem
hlt

hlt
                in      al,60h
                cmp     al,1
                jne     ._3drot_mainloop
;                jmp     ._3drot_mainloop


 popa
 popfwide
retwide







  _3drot_points        equ 200*3

  _3drot_xangle        ww 0
  _3drot_yangle        ww 0
  _3drot_zangle        ww 0

  _3drot_xsin          ww 0
  _3drot_xcos          ww 0
  _3drot_ysin          ww 0
  _3drot_ycos          ww 0
  _3drot_zsin          ww 0
  _3drot_zcos          ww 0

  _3drot_xt            ww 0
  _3drot_yt            ww 0
  _3drot_zt            ww 0

  _3drot_x             ww 0
  _3drot_y             ww 0
  _3drot_z             ww 0




  %include       "sincos.asm"
  %include	"coords.asm"

  _3drot_erase          times _3drot_points ww 0







%include "VGA/main.asm"
